var Cus01000_RankingDePratosController = function(Parametros, General, ScreenService, GeneralServices) {
/*global moment, getLocalVar, Configuration*/
	var self = this;

	this.habilitaFields = function(widget) {
		if (!widget.currentRow.REPORT_NAME) {
			widget.newRow();
		}
		var opcao = widget.currentRow.CDTIPORECE;
		var filialLogada = getLocalVar('CDFILIAL');
		var nomeFilialLogada = getLocalVar('NMFILIAL');
		let unitNameWithCode = filialLogada + ' | ' + nomeFilialLogada;
		let serviceField = widget.getField('NMSERVICO');
		let unitField = widget.getField('NMFILIAL');

		if (opcao === "P") {

			unitField.readOnly = true;
			serviceField.readOnly = true;

			unitField.validations = {};
			serviceField.validations = {};

			widget.currentRow.CDFILIAL = filialLogada;
			widget.currentRow.CDSERVFILI = '';
			widget.currentRow.NMSERVICO = '';
			unitField.setValue(unitNameWithCode);
			serviceField.setValue("");
		} else if (opcao === "F") {
			unitField.readOnly = false;
			serviceField.readOnly = true;

			unitField.validations = {
				required: true
			};
			serviceField.validations = {};

			serviceField.setValue("");
			widget.currentRow.CDSERVFILI = '';
			widget.currentRow.NMSERVICO = '';
		} else if (opcao === "S") {
			unitField.validations = {
				required: true
			};
			serviceField.validations = {
				required: true
			};

			unitField.readOnly = false;
			serviceField.readOnly = false;
			reloadService(widget);
		}
	};

	this.geraDataSource = function(widget, dataSource) {
		var objLevel = {
			nivel: "0",
			caracteres: "0"
		};

		let dataset = General.getLevelByMask('CDPICTPRAT', 1);
		dataset.pop();
		dataset.pop();
		widget.getField('NMTAMACNIVEL').dataSource.data = dataset;
		widget.getField('NMTAMACNIVEL').dataSource.data.unshift(objLevel);

		widget.getField('CDTIPORECE').applyDefaultValue();

		widget.currentRow.NMTAMACNIVEL = objLevel.nivel;
		widget.currentRow.NRTAMACNIVEL = objLevel.caracteres;
		
		self.habilitaFields(widget);
		self.geraNivelPrato(widget);
		self.reloadPratos(widget);
		
		GeneralServices.retornaTipoCustoPadrao(getLocalVar('CDFILIAL')).then(function(callback) {
			if (callback.dataset.defaulttipocusto.length) {
				widget.getField('NMTIPOCUSTO').setValue(ScreenService.i18n(callback.dataset.defaulttipocusto[0].NMTIPOCUSTO));
				widget.currentRow.CDTIPOCUSTO = callback.dataset.defaulttipocusto[0].CDTIPOCUSTO;
			}
		});
	};

	this.geraNivelPrato = function(widget) {
		var nivelPrato = getLocalVar('CDPICTPRAT').split('.').length.toString();
		widget.getField('CDNVPRATO').setValue(nivelPrato);
	};

	this.insereNivelPrato = function(widget) {
		var nivelPrato = getLocalVar('CDPICTPRAT').split('.').length.toString();
		widget.getField('CDNVPRATO').setValue(nivelPrato);
		widget.currentRow.NRTAMACNIVEL = widget.currentRow.NMTAMACNIVEL;
	};

	this.validaNivel = function(currentRow) {
		var mensagem = ScreenService.i18n("O prato final não pode ser maior que o inicial.");
		var retorno = '';

		if (currentRow.CDPRATOINI && currentRow.CDPRATOFIM) {
			retorno = General.comparaPratoProduto(currentRow.CDPRATOINI, currentRow.CDPRATOFIM, getLocalVar('CDPICTPRAT'));
			if (!retorno) {
				ScreenService.showMessage(mensagem);
				return false;
			}
			return true;
		}
		return false;
	};

	this.validaCampos = function(widget, field, args) {
		let reportFormats = [
			{
				name: "pdf",
				value: "PDF"
			},
			{
				name: "xlsx",
				value: "XLSX"
			}
		];
		if (widget.isValid() && this.validaNivel(widget.currentRow)) {
			General.openReportPopup(widget, this.abreRelatorio, [field, args], reportFormats);
		}

	};

	this.abreRelatorio = function(field, args) {
		Parametros.retornaDataProcessamento().then(function(callback) {
			args.row.CDPICTPRAT = getLocalVar('CDPICTPRAT').replace(/[^(/\.|\ )]/g, "@");
			args.row.NRORG = getLocalVar('NRORG');
			field.setValue(moment(callback, 'L').format('DD/MM/YYYY'));
			General.openReport('cus_relatorio#/cus01000_ranking_de_pratos', 'CUS01000', args.row);
		});
	};
	
	this.alteraPrato = function(field) {
		let widget = field.widget;
		if(field.name === 'NMPRATOINICIO') {
			widget.currentRow.NMPRATOFINAL = angular.copy(widget.currentRow.NMPRATOINICIO);
			widget.currentRow.CDPRATOINI = angular.copy(widget.currentRow.CDPRATO);
			widget.currentRow.CDPRATOFIM = angular.copy(widget.currentRow.CDPRATOINI);
		} else {
			widget.currentRow.CDPRATOFIM = angular.copy(widget.currentRow.CDPRATO);
		}
	};

	this.retornaGrupServ = function(currentRow) {
		if (currentRow.ALLCDGRUPSERV == 'N') {
			if (Array.isArray(currentRow.NMGRUPSERV)) {
				return currentRow.NMGRUPSERV.join('_');
			}
			else {
				return "";
			}
		} else {
			return 'T';
		}
	};

	this.reloadPratos = function(widget){
		var pratoInicio = widget.getField('NMPRATOINICIO');
		var pratoFinal = widget.getField('NMPRATOFINAL');
		
		pratoInicio.dataSourceFilter = [{
			"operator": "ORDER_BY",
			"name": [{
				"name": "CDPRATO",
				"direction": "ASC"
			}]
		},
		{
			"name": "CDFILAUXPRAT",
			"operator": "=",
			"value": widget.currentRow.CDFILIAL
		}];
			
		pratoFinal.dataSourceFilter = [{
			"operator": "ORDER_BY",
			"name": [{
				"name": "CDPRATO",
				"direction": "ASC"
			}]
		},
		{
			"name": "CDFILAUXPRAT",
			"operator": "=",
			"value": widget.currentRow.CDFILIAL
		}];
		
		pratoInicio.reload();
		pratoFinal.reload();
	};

	function reloadService (widget) {
		let serviceField = widget.getField('NMSERVICO');
		if(serviceField.readOnly || !serviceField.isVisible){
			return;
		}
		var filterData = {
			CDFILIAL: widget.currentRow.CDFILIAL || '',
			CDGRUPSERV: self.retornaGrupServ(widget.currentRow)
		};
		General.buildDataSourceFilter(serviceField.dataSourceFilter, filterData);
		serviceField.reload();
	}

	this.onChangeUnit = function(unitField){
		let row = unitField.widget.currentRow;
		let widget = unitField.widget;
		widget.getField('NMSERVICO').setValue('');
		row.CDSERVFILI = '';
		row.NMSERVICO = ''; 
		if(!unitField.value()){
			row.CDFILIAL = '';
		}
		this.reloadPratos(widget);
		reloadService(widget);
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Cus01000_RankingDePratosController', Cus01000_RankingDePratosController);
});